// Weather.h

#ifndef _WEATHER_h
#define _WEATHER_h

#if defined(ARDUINO) && ARDUINO >= 100
	#include "arduino.h"
#else
	#include "WProgram.h"
#endif

#include "HPController.h"
#include <WiFiClient.h>

struct WeatherForecast {
	time_t forecastTime;
	int temperature;
	int feelsLike;
	int pressure;
	int humidity;
	int desiredTemperature;
	int desiredFeelLikeTemperature;
	double dewpoint;
};

class WeatherClass
{
 protected:
	 WiFiClient client;

	 const char* weatherserver = "api.openweathermap.org";
	 const unsigned long HTTP_TIMEOUT = 10000;  // max respone time from server

	 int heatingRequirements[56] = { 44,44,44,44,44,44,43,43,42,40,38,38,38,35,34,34,34,34,34,34,34,32,30,28,28,26,26,24,24,22,21,21,22,23,24,25,26,27,28,20,20,20,20,16,16,16,16,16,12,12,12,12,12,12,12,12};
	//  Temperature                -10,-9,-8,-7,-6,-5,-4,-3,-2,-1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45 
	bool sendRequest(WiFiClient client, const char* host, const char* resource);
	bool skipResponseHeaders(WiFiClient client);
	float truncate(float val, byte dec);
	double dewPoint(double celsius, double humidity);
 
public:
	WeatherForecast forecast[4];
	void init();
	void getWeather();
	void getCurrentWeather();
	int getRequiredTemperature(int temperature, time_t t);
	void sendWeatherJson();
};

extern WeatherClass Weather;

#endif

